/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include "icon.h"

class CNodeItem : public QListViewItem
{
public:
	CNodeItem (QListView *pParent, CNode *pNode) : 
	  QListViewItem (pParent, QString("A %1").arg (pNode->m_iBAB), pNode->m_strNumber, pNode->m_strName, pNode->GetTypeText(), pNode->GetStatusText())
	  {
		  m_pNode = pNode;
		  setPixmap (0, pNode->GetPixmap16());

//		  if (!pNode->WarningText().isEmpty())
//			  setPixmap (2, IconWarning16());
	  }

	CNode *m_pNode;
};

void CDlgNodeSelect::onDoubleClicked( QListViewItem *pItem )
{
	accept ();
}


void CDlgNodeSelect::onOK()
{
	if (m_listView->selectedItem() == NULL)
	{
		QMessageBox::information (this, tr("Information"), tr("You should select a node!"));
		return;
	}
	else accept ();
}


void CDlgNodeSelect::init()
{
    m_listView->addColumn (tr("BAB"), 80);
    m_listView->addColumn (tr("Node"), 50);
    m_listView->addColumn(tr("Name"),170);
    m_listView->addColumn(tr("Type"),100);
    m_listView->addColumn(tr("Status"),100);

	m_listView->setSortColumn(-1);
	m_listView->setAllColumnsShowFocus(true);
}


CNode* CDlgNodeSelect::go( QPtrList<CNode> &list )
{
CNode *pNode=NULL;
	m_listView->clear ();
	for (pNode = list.last(); pNode != NULL; pNode = list.prev())
	{
		new CNodeItem (m_listView, pNode);
	}

	while (exec () == QDialog::Accepted && m_listView->selectedItem() != NULL)
	{
		CNodeItem *pItem = (CNodeItem*)m_listView->selectedItem();
		return pItem->m_pNode;
	}
	return NULL;
}
